package com.energy.manage.service.property.analysis;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 算法属性值
 * @author chy
 * @date 2024/5/30 17:37
 * @desc
 */
@Component
public class AlgorithmProperties {

    /**
     * 算法地址
     */
    public static String analysisUrl;

    /**
     * 传给分析算法json
     */
    public static String analysisJson;

    /**
     * 图像设置参数属性
     */
    public static List<String> graphSetsProperties;

    /**
     * 分析类型属性
     */
    public static String configAnalysisProperties;


    @Value("${analysis.url}")
    public void setAnalysisUrl(String analysisUrl){
        AlgorithmProperties.analysisUrl = analysisUrl;
    }

    @Value("${analysis.json}")
    public void setAnalysisJson(String analysisJson){
        AlgorithmProperties.analysisJson = analysisJson;
    }

    @Value("${graphSets.properties}")
    public void setGraphSetsProperties(List<String> graphSetsProperties){
        AlgorithmProperties.graphSetsProperties = graphSetsProperties;
    }

    @Value("${analysis.properties}")
    public void setConfigAnalysisProperties(String configAnalysis){
        AlgorithmProperties.configAnalysisProperties = configAnalysis;
    }
}
