package com.energy.manage.service.task;

import com.energy.manage.service.domain.dto.analysis.AnalysisAlgorithmDto;
import com.energy.manage.service.domain.dto.analysis.AnalysisDto;
import com.energy.manage.service.service.analysis.AnalysisService;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 自动分析定时任务
 * @author chy
 * @date 2024/6/2 21:35
 * @desc
 */
@Slf4j
@Component
public class AutoAnalysisTask {

    @Autowired
    private AnalysisService analysisService;


    /**
     * 自动分析
     */
    @XxlJob(value = "autoAnalysis")
    public void autoAnalysis() {
        log.info("触发自动分析定时任务开始");
        analysisService.analysis(new AnalysisDto());
        log.info("触发自动分析定时任务结束");
    }
}
