package com.energy.manage.service.test;

import com.energy.manage.service.domain.dto.analysis.AnalysisDto;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author chy
 * @date 2024/6/2 19:06
 * @desc
 */
public class TestJson {


    public static void main(String[] args) throws JsonProcessingException {
        String jsonString = "{\n" +
                "        \"dataContractType\": {\n" +
                "            \"type\": \"analysisExecuteOrder\",\n" +
                "            \"version\": \"1.2.0\"\n" +
                "        },\n" +
                "        \"dataContract\": {\n" +
                "            \"autoOrManual\":\"automatic\",\n" +
                "            \"dataSource\": {\n" +
                "                \"scada\": \"second\"\n" +
                "            },\n" +
                "            \"dataFilter\": {\n" +
                "                \"powerFarmID\": \"010-00001\",\n" +
                "                \"turbines\": [\n" +
                "                    \"010-00001-0001\",\n" +
                "                    \"010-00001-0002\"\n" +
                "                ],\n" +
                "                \"dataBatchNum\": \"B2024042211-0\",\n" +
                "                \"beginTime\": \"2023-01-01 00:00:00\",\n" +
                "                \"endTime\": \"2023-12-31 23:59:59\",\n" +
                "                \"excludingMonths\": [\n" +
                "                    \"2023-12\",\n" +
                "                    \"2023-09\"\n" +
                "                ],\n" +
                "                \"customFilter\": {\n" +
                "                    \"valueWindSpeed\": {\n" +
                "                        \"min\": 3.0,\n" +
                "                        \"max\": 25.0\n" +
                "                    },\n" +
                "                    \"valuePitchAngle\": {\n" +
                "                        \"min\": 2,\n" +
                "                        \"max\": null\n" +
                "                    },\n" +
                "                    \"valueActivePower\": {\n" +
                "                        \"min\": 10,\n" +
                "                        \"max\": 2500\n" +
                "                    },\n" +
                "                    \"valueGeneratorSpeed\": {\n" +
                "                        \"min\": 10,\n" +
                "                        \"max\": 2500\n" +
                "                    }\n" +
                "                }\n" +
                "            },\n" +
                "            \"configAnalysis\": [\n" +
                "                {\n" +
                "                    \"package\": \"algorithm.powerCurveAnalyst\",\n" +
                "                    \"className\": \"PowerCurveAnalyst\",\n" +
                "                    \"methodName\": \"executeAnalysis\"\n" +
                "                },\n" +
                "                {\n" +
                "                    \"package\": \"algorithm.powerScatter2DAnalyst\",\n" +
                "                    \"className\": \"PowerScatter2DAnayst\",\n" +
                "                    \"methodName\": \"executeAnalysis\"\n" +
                "                },\n" +
                "                {\n" +
                "                    \"package\": \"algorithm.powerScatterAnalyst\",\n" +
                "                    \"className\": \"PowerScatterAnalyst\",\n" +
                "                    \"methodName\": \"executeAnalysis\"\n" +
                "                },\n" +
                "                {\n" +
                "                    \"package\": \"algorithm.windSpeedFrequencyAnalyst\",\n" +
                "                    \"className\": \"WindSpeedFrequencyAnalyst\",\n" +
                "                    \"methodName\": \"executeAnalysis\"\n" +
                "                },\n" +
                "                {\n" +
                "                    \"package\": \"algorithm.generatorSpeedPowerAnalyst\",\n" +
                "                    \"className\": \"GeneratorSpeedPowerAnalyst\",\n" +
                "                    \"methodName\": \"executeAnalysis\"\n" +
                "                }\n" +
                "            ],\n" +
                "            \"graphSets\": {\n" +
                "                \"generatorSpeed\": {\n" +
                "                    \"step\": 200,\n" +
                "                    \"min\": 1000,\n" +
                "                    \"max\": 2000\n" +
                "                },\n" +
                "                \"generatorTorque\": {\n" +
                "                    \"step\": 2000,\n" +
                "                    \"min\": 0,\n" +
                "                    \"max\": 12000\n" +
                "                },\n" +
                "                \"cp\": {\n" +
                "                    \"step\": 0.5,\n" +
                "                    \"min\": 0,\n" +
                "                    \"max\": 2\n" +
                "                },\n" +
                "                \"tsr\": {\n" +
                "                    \"step\": 5,\n" +
                "                    \"min\": 0,\n" +
                "                    \"max\": 30\n" +
                "                },\n" +
                "                \"pitchAngle\": {\n" +
                "                    \"step\": 1,\n" +
                "                    \"min\": -1,\n" +
                "                    \"max\": 20\n" +
                "                },\n" +
                "                \"activePower\": {\n" +
                "                    \"step\": 250,\n" +
                "                    \"min\": 0,\n" +
                "                    \"max\": 2000\n" +
                "                }\n" +
                "            }\n" +
                "        }\n" +
                "    }";

        ObjectMapper mapper = new ObjectMapper();
        JsonNode rootNode = mapper.readTree(jsonString);
//        AnalysisDto dto = new AnalysisDto();
//        dto.setBeginTime("1234-12-12 00:00:12");
//        updateNodesByPropertyName(rootNode, "beginTime", dto);
//        String propertyNameToFind = "beginTime";
//        List<JsonNode> matchingNodes = findNodesByPropertyName(rootNode, propertyNameToFind);
//
//        for (JsonNode node : matchingNodes) {
//            System.out.println("Found matching node: " + mapper.writerWithDefaultPrettyPrinter().writeValueAsString(node));
//        }

        AnalysisDto dto = new AnalysisDto();
        dto.setBeginTime("1234-12-12 00:00:12");
        dto.setExcludingMonths(Arrays.asList("1","2","3"));
        setValue(dto,rootNode);
        System.out.println();
        for (JsonNode node : rootNode) {
            System.out.println("Found matching node: " + mapper.writerWithDefaultPrettyPrinter().writeValueAsString(node));
        }

    }

    public static List<JsonNode> findNodesByPropertyName(JsonNode node, String propertyName) {
        List<JsonNode> result = new ArrayList<>();
        findNodesByPropertyNameRecursive(node, propertyName, result);
        return result;
    }

    private static void findNodesByPropertyNameRecursive(JsonNode node, String propertyName, List<JsonNode> result) {
        if (node.isObject()) {
            node.fields().forEachRemaining(entry -> {
                if (entry.getKey().equals(propertyName)) {
                    // 匹配到属性名称，添加节点到结果列表
                    result.add(entry.getValue());
                }
                // 递归搜索子节点
                findNodesByPropertyNameRecursive(entry.getValue(), propertyName, result);
            });
        }
    }

    private static void updateNodesByPropertyName(JsonNode node, String propertyName,String value) {
        if (node.isObject()) {
            node.fields().forEachRemaining(entry -> {
                // 匹配到属性名称，进行值的修改
                if (entry.getKey().equals(propertyName)) {
                    ((ObjectNode) node).put(propertyName, value);
                }
                // 递归搜索子节点
                updateNodesByPropertyName(entry.getValue(), propertyName, value);
            });
        }
    }

    /**
     * 获取前端参数
     * @param analysisDto
     * @return
     */
    private static void setValue(AnalysisDto analysisDto,JsonNode jsonNode) {
        //前端入参类
        Field[] analysisFields = analysisDto.getClass().getDeclaredFields();
        Arrays.asList(analysisFields).stream().forEach(field -> {
            field.setAccessible(true);
            try {
                if(field.get(analysisDto) != null){
                    updateNodesByPropertyName(jsonNode, field.getName(), field.get(analysisDto).toString());
                }
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            }
        });
    }
}
